package asm

import "fmt"

// Instruction represents a single instruction which can be converted to machine code.
type Instruction struct {
	Mnemonic Mnemonic
	Data     interface{}
}

// String returns a human readable version.
func (x *Instruction) String() string {
	switch data := x.Data.(type) {
	case RegisterNumber:
		return fmt.Sprintf("%s %s, %x", x.Mnemonic, data.Register, data.Number)
	default:
		return x.Mnemonic.String()
	}
}
